Foreman - Bug #15655

[upgrade] db migrate failed with error: undefined local variable or method ‘openscap_proxy _id'

07/12/2016 06:01 AM - Shlomi Zadok

Status: Closed
Priority: Normal
Assignee: Shlomi Zadok
Category: DB migrations
Target version: 1.13.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: 1353436 Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/3639
Description

Cloned from https://bugzilla.redhat.com/show_bug.cqi?id=1353436
Description of problem:
While performing upgrade from sat6.1.9 -> sat62 GA snap19, db:migration failed with error:

StandardError: An error has occurred, this and all later migrations canceled:

undefined local variable or method “openscap_proxy_id' for

#<Hostgroup:0x0000000df0b150>/opt/rh/rh-ror41/root/usr/share/gems/gems/activemodel-4.1.5/lib/active_model/attribute_methods.rb

:435:in "'method_missing'

/opt/rh/rh-ror41/root/usr/share/gems/gems/activerecord-4.1.5/lib/active_record/attribute_methods.rb:208:in “method_missing'
/opt/theforeman/tfm/root/usr/share/gems/gems/foreman_openscap-0.5.3.14/app/models/concerns/foreman_openscap/openscap_pro

Xy_core_extensions.rb:66:in “openscap_proxy_has_feature'

/opt/rh/rh-ror41/root/usr/share/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:424:in
/opt/rh/rh-ror41/root/usr/share/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:184:in
/opt/rh/rh-ror41/root/usr/share/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:184:in
/opt/rh/rh-ror41/root/usr/share/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:185:in
/opt/rh/rh-ror41/root/usr/share/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:185:in
/opt/rh/rh-ror41/root/usr/share/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:185:in
/opt/rh/rh-ror41/root/usr/share/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:185:in
/opt/rh/rh-ror41/root/usr/share/gems/gems/activesupport-4.1.5/lib/active_support/callbacks.rb:185:in

Version-Release number of selected component (if applicable):
sat62 GA snap19

How reproducible:
always

Steps to Reproduce:

0. Make sure openscap packages are installed on sat6.1
1. set Sat6.2 repo

2. katello-service stop

3. yum update -y

4. satellite-installer --scenario satellite --upgrade

Actual results:

Expected results:
db: migration succeed and installer should complete successfully

Additional info:

“block in make_lambda’
“call

“block in simple’

“call

“block in simple’

“call'

“block in simple’

“call
https://bugzilla.redhat.com/show_bug.cgi?id=1353436

Revision cf37d1f4 - 07/13/2016 08:56 AM - Shlomi Zadok
Fixes #15655 - Improve ptable migration

Update host and hostgroups in migration without running validation. Some
plugins failed to run the migration because Host or Hostgroups added
validations for fields that did not exist at the time this migration was
created.

This change also improves performance of the migration by using the
‘update_all' method instead of looping over all elements.

History

#1 - 07/12/2016 07:01 AM - Shlomi Zadok
- Project changed from OpenSCAP to Foreman

- Category set to Database

The problem is at the migration itself, as ptable_id is set on the hostgroup (hence an update on hostgroup)
This may happen on other plugins that add validation to the hostgroup.

#2 - 07/12/2016 07:04 AM - The Foreman Bot
- Status changed from New to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/3639 added

#3 - 07/12/2016 09:31 AM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman_openscap/pull/178 added

#4 - 07/13/2016 09:01 AM - Shlomi Zadok
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset cf37d1f470c6eb898b65f0355360684abbabde16.

#5 - 07/13/2016 10:03 AM - Dominic Cleal
- Category changed from Database to DB migrations

- translation missing: en.field_release set to 160

#6 - 07/13/2016 10:07 AM - Ohad Levy
- Pull request deleted (https://github.com/theforeman/foreman_openscap/pull/178)

#7 - 07/27/2016 12:06 PM - Ivan Necas

- Related to Refactor #15866: Provide alternative way of migrating data as oposed misuing db:migrate for this purpose added

05/18/2024
